import { CSSProperties, HTMLAttributes, PureComponent, ReactNode } from 'react';
declare const defaultProps: {
    maxValue: number;
    placement: string;
    color: string;
    zIndex: number;
};
export declare type BadgeProps = {
    /** 显示内容 */
    value?: ReactNode;
    /** 为数字时能显示的最大值，超过将显示最大值+ */
    maxValue?: number;
    /** 显示为点状 */
    dot?: boolean;
    /** badge 的位置 */
    placement?: 'topRight' | 'topLeft' | 'bottomRight' | 'bottomLeft' | 'top' | 'bottom' | 'left' | 'right';
    /** 为 0 时是否隐藏 */
    hideWhenZero?: boolean;
    /** badge的样式 */
    badgeStyle?: CSSProperties;
    /** 定义 badge 的偏移，第一个参数 x 轴偏移量，第二个值为 y 轴偏移量 */
    offset?: [number, number];
    /** 定位的内容，为空时仅展示 Badge，定位等属性不生效 */
    children?: ReactNode;
    /** 选择预设的颜色 */
    color?: 'red' | 'green' | 'yellow' | 'primary';
    /** badge 的 zIndex */
    zIndex?: number;
} & typeof defaultProps & HTMLAttributes<HTMLDivElement>;
declare class Badge extends PureComponent<BadgeProps> {
    static defaultProps: {
        maxValue: number;
        placement: string;
        color: string;
        zIndex: number;
    };
    static Placement: string[];
    static Color: string[];
    renderBadge: () => JSX.Element;
    getTarget: () => Element | Text | null;
    render(): JSX.Element;
}
export default Badge;
