import React from 'react';
import { Moment } from 'moment';
import { TDate } from '@ucloud-fe/calendar';
import { Rules } from './utils';
import LOCALE from './locale/zh_CN';
export interface CalendarProps {
    /** 当前值，受控 */
    value?: TDate | null;
    /** 范围值 */
    rangeValue?: [TDate | null, TDate | null];
    /** 默认值，非受控 */
    defaultValue?: TDate | null;
    /**
     * @deprecated 使用 onChange 来替换
     */
    onSelect?: (t: Moment) => void;
    /** 选中变化回调 */
    onChange?: (t: Moment) => void;
    current?: TDate;
    defaultCurrent?: TDate;
    onCurrentChange?: (v: TDate) => void;
    /** 自定义规则 */
    rules?: Rules;
    /** 自定义样式 */
    customStyle?: {
        /**
         * 外层阴影，为 false 时隐藏
         */
        boxShadow?: boolean;
    };
    /** 类型 */
    type?: 'date' | 'month';
    /** @ignore */
    locale?: typeof LOCALE;
}
declare const _default: React.MemoExoticComponent<({ type, ...props }: CalendarProps) => JSX.Element>;
export default _default;
