import React, { ReactNode } from 'react';
import { Size, StyleType, Value } from './interface';
export interface CheckboxProps {
    /** 是否选中 */
    checked?: boolean;
    /** 默认是否选中 */
    defaultChecked?: boolean;
    /** 是否禁用 */
    disabled?: boolean;
    /** 点选时的回调 */
    onChange?: (value: boolean) => void;
    /** 一般用于全选，部分选中的状态 */
    indeterminate?: boolean;
    /** checkbox的值 */
    value?: Value;
    /** 尺寸，styleType 为 card 时无效 */
    size?: Size;
    /** 样式风格 */
    styleType?: StyleType;
    /** 标题，styleType 为 card 时使用 */
    title?: ReactNode;
    /**
     * @ignore
     * @deprecated 弃用
     */
    disabledLabel?: ReactNode;
}
declare const _default: React.MemoExoticComponent<({ defaultChecked, checked: _checked, onChange: _onChange, value, onClick, disabledLabel, ...restProps }: CheckboxProps & Omit<React.HTMLAttributes<HTMLElement>, keyof CheckboxProps>) => JSX.Element>;
export default _default;
