import { HTMLAttributes, PureComponent, ReactNode } from 'react';
declare const defaultProps: {
    styleType: string;
    size: string;
};
declare type ButtonProps = {
    /** 按钮类型 */
    styleType?: 'primary' | 'border' | 'border-gray';
    /** 按钮尺寸 */
    size?: 'sm' | 'md' | 'lg';
    /** 形状 */
    shape?: 'circle' | 'square';
    /** 图标，传入 string 时为图标类型，也可直接传入图标组件，需要图标位置等更多自定义请直接放在 children 中 */
    icon?: string | ReactNode;
} & typeof defaultProps & HTMLAttributes<HTMLAnchorElement>;
export default class Button extends PureComponent<ButtonProps> {
    static defaultProps: {
        styleType: string;
        size: string;
    };
    renderIcon: () => {} | null | undefined;
    render(): JSX.Element;
}
export {};
