import React, { ReactNode, MouseEvent, HTMLAttributes } from 'react';
export declare const StyleTypes: ["default", "success", "warning", "error", "disabled"];
export declare type NoticeProps = {
    /** 是否显示关闭按钮 */
    closable?: boolean;
    /** 自定义前置icon，可传入Icon type或者自定义Icon，传入null、false隐藏，默认显示感叹号icon */
    icon?: null | false | string | ReactNode;
    /** 关闭的回调 */
    onClose?: (e: MouseEvent) => void;
    /** 样式类型 */
    styleType?: 'default' | 'success' | 'warning' | 'error' | 'disabled' | 'info';
    /** 自定义操作 */
    action?: ReactNode;
} & HTMLAttributes<HTMLDivElement>;
declare const _default: React.MemoExoticComponent<({ closable, icon: _icon, children, onClose, styleType, action, ...rest }: NoticeProps) => JSX.Element | null>;
export default _default;
