import React, { HTMLAttributes, ReactNode } from 'react';
export interface DefinedTabPaneProps {
    /** @ignore */
    className?: string;
    /**
     * @ignore
     * 内部属性
     */
    active?: boolean;
    /**
     * @ignore
     * 内部属性
     */
    destroyInactiveTabPane?: boolean;
    /** 是否强制渲染 */
    forceRender?: boolean;
    /** @ignore */
    placeholder?: ReactNode;
    /** 面板内容 */
    children?: ReactNode;
    /** 是否禁用 */
    disabled?: boolean;
    /** tab 的 title */
    tab: ReactNode;
    /** tab 的 key，由于 react 会在某些情况下改变传递的 key，顾直接使用 key 是不安全的，如发现 key 被修改，可使用 tabKey 来替换 */
    tabKey?: string;
}
export declare type TabPaneProps = DefinedTabPaneProps & Omit<HTMLAttributes<HTMLDivElement>, keyof DefinedTabPaneProps>;
declare const _default: React.MemoExoticComponent<({ className, active, destroyInactiveTabPane, forceRender, placeholder, children, tabKey, tab, ...rest }: TabPaneProps) => JSX.Element>;
export default _default;
