import React from 'react';
import { Moment } from 'moment';
import { TDate } from '@ucloud-fe/calendar';
import { Size } from '../../style';
import LOCALE from './locale/zh_CN';
interface TimeProps {
    /** 当前值，受控 */
    value?: TDate | null;
    /** 默认值，非受控 */
    defaultValue?: TDate | null;
    /** 修改回调 */
    onChange?: (value: Moment | null) => void;
    /** 自定义 Popover 的 props */
    popoverProps?: any;
    /** 是否可为空 */
    nullable?: boolean;
    /** 自定义展示格式 */
    format?: string;
    /** 是否禁用 */
    disabled?: boolean;
    /** 尺寸 */
    size?: Size;
    /** @ignore */
    locale?: typeof LOCALE;
}
declare const _default: React.MemoExoticComponent<({ value: _value, defaultValue, onChange: _onChange, format: _format, nullable, size, disabled, popoverProps, locale }: TimeProps) => JSX.Element>;
export default _default;
