import React, { ReactNode } from 'react';
import { ChangeKeyMap, Group, SelectedMap, Key, LoadData } from './interface';
export interface SharedItemProps {
    title: ReactNode;
    disabled?: boolean;
    depth: number;
    isLatest?: boolean;
    multiple?: boolean;
}
declare const MemoChildItem: React.MemoExoticComponent<({ value, onSelect, ignoreIndent, selectedMap, ...rest }: {
    value: Key;
    onSelect: (keyMap: ChangeKeyMap) => void;
    ignoreIndent: number[];
    selectedMap: SelectedMap;
} & SharedItemProps) => JSX.Element>;
declare const MemoTitleItem: React.MemoExoticComponent<({ value, onSelect, ignoreIndent, selectedMap, group, onExpandChange, loadData, loaded, ...rest }: {
    value: Key;
    onSelect: (keyMap: ChangeKeyMap) => void;
    expanded?: boolean | undefined;
    onExpandChange?: ((expanded: boolean) => void) | undefined;
    ignoreIndent: number[];
    selectedMap: SelectedMap;
    group: Group;
    loadData?: LoadData | undefined;
    loaded?: boolean | undefined;
} & SharedItemProps) => JSX.Element>;
export { MemoChildItem as ChildItem, MemoTitleItem as TitleItem };
