/// <reference types="react" />
/**
 * 计算容器内的元素最大展示数量
 * @returns {[number, number, boolean]} [当前测试的展示数, 最终确定的展示数, 是否在测试过程中]
 */
declare const useOverflow: ({ containerRef, defaultCount, maxCount, minCount }: {
    /**
     * 容器元素的 ref
     */
    containerRef?: import("react").MutableRefObject<HTMLElement | null> | undefined;
    /**
     * 默认的初始展示数量
     */
    defaultCount?: number | undefined;
    /**
     * 最大展示数量，一般传入元素数量即可
     */
    maxCount: number;
    /**
     * 最小展示数量
     */
    minCount?: number | undefined;
}, deps?: any[]) => [number, number, boolean];
export default useOverflow;
